diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/linepanel.py sketch1/Sketch/UI/linepanel.py
--- sketch.orig/Sketch/UI/linepanel.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/linepanel.py	2005-03-19 21:36:34.000000000 +0100
@@ -0,0 +1,562 @@
+
+import gtk
+import types
+import operator
+from math import log10
+from sets import Set
+
+import Sketch
+import Sketch.Graphics
+from Sketch import _, Point, CreatePath
+from Sketch._sketch import ContAngle
+from Sketch.Lib.units import unit_dict
+from Sketch.Base import Publisher
+from Sketch.Base.const import EDITED, CHANGED, SELECTION, OBJECT_CHANGED, \
+     STYLE, TRANSACTION_END, CapButt, CapRound, CapProjecting, \
+     JoinMiter, JoinRound, JoinBevel
+from Sketch.Graphics import StandardColors, PropertyStack,\
+     EmptyPattern, SolidPattern, CreateRGBColor, StandardDashes, \
+     LineStyle
+from Sketch.Graphics.arrow import StandardArrows
+from Sketch.Graphics.properties import set_graphics_defaults, \
+     DefaultGraphicsProperties, property_names
+
+from gtkmisc import CommonOptionMenu, PixmapMenu, UnitMenu
+from scratchpad import ScratchPad
+from request import ColorButton
+import skpixmaps
+
+pixmaps = skpixmaps.pixmaps
+black = StandardColors.black
+
+from Sketch import _, const
+from skpanel import MultiPanel, PanelMenu, Card
+
+# find properties common to several PropertyStacks
+def common_properties(plist):
+    """Return the properties all PropertyStacks in plist have in common.
+
+    The return value is a dict mapping property names to their values.
+    """
+    common = {}
+    conflicts = {}
+    for p in plist:
+        for property in property_names:
+            if hasattr(p, property):
+                value = getattr(p, property)
+                if common.has_key(property):
+                    if value != common[property]:
+                        conflicts[property] = 1
+                else:
+                    common[property] = value
+    for conflict in conflicts.keys():
+        del common[conflict]
+    return common
+
+# construct a PropertyStack with properties common to several objects
+def common_object_properties(objects):
+    plist = [obj.Properties() for obj in objects if obj.has_properties]
+    common = common_properties(plist)
+    pstack = DefaultGraphicsProperties() # XXX or text properties?
+    apply(pstack.SetProperty, (), common)
+    return pstack
+
+
+
+
+class ArrowMenu(CommonOptionMenu):
+
+    """Option Menu for Arrow Heads.
+
+    The arrows shown are taken from StandardArrows()
+    """
+
+    mode = CommonOptionMenu.TEMPORARY_EXTENSION
+
+    def __init__(self, direction):
+        """Initialize the arrow menu.
+
+        If direction is 1 the arrow points to the right, if it's 0 to
+        the left.
+        """
+        CommonOptionMenu.__init__(self, [None] + StandardArrows())
+        self.direction = direction
+
+    def GeneratePixmaps(self, window, width = 32, height = 16):
+        pad = ScratchPad(window, width, height, 1.0, libart = 1)
+        maps = []
+        scale = 1.0
+        arrow_props = PropertyStack()
+        arrow_props.AddStyle(LineStyle(black, 1))
+        origin_props = PropertyStack()
+        origin_props.AddStyle(LineStyle(CreateRGBColor(0.1, 0.1, 0.1), 1,
+                                        dashes = (2, 2)))
+        origin_path = CreatePath()
+        origin_path.AppendLine(Point(0, -height/2), ContAngle)
+        origin_path.AppendLine(Point(0, height/2), ContAngle)
+        for arrow in self.values:
+            pad.BeginDraw()
+            pad.DrawRectangle(-width/2, -height/2, width/2, height/2)
+            pad.SetProperties(origin_props)
+            pad.MultiBezier((origin_path,))
+            pad.SetProperties(arrow_props)
+            pad.PushTrafo()
+            pad.Scale(2)
+            if not self.direction:
+                pad.Scale(-1)
+            if arrow is not None:
+                retract = arrow.retract
+                arrow.Draw(pad)
+            else:
+                retract = 0
+            path = CreatePath()
+            path.AppendLine(Point(-width/2, 0), ContAngle)
+            path.AppendLine(Point(-retract, 0), ContAngle)
+            pad.MultiBezier((path,))
+            pad.PopTrafo()
+            pad.EndDraw()
+            maps.append(pad.GetPixmap())
+        return maps
+
+    def build_options(self):
+        window = self.window
+        images = []
+        for pixmap in self.GeneratePixmaps(window):
+            image = gtk.Image()
+            image.set_from_pixmap(pixmap, None)
+            images.append(image)
+        return images, 0
+
+
+from rendermisc import DashesSample, LineThicknessSample, WidgetRenderer
+
+class DashesWidget(DashesSample, WidgetRenderer):
+    default_size = (110, 16)
+
+class ThicknessWidget(LineThicknessSample, WidgetRenderer):
+    default_size = (90, 16)
+
+class LineDashesMenu(CommonOptionMenu):
+
+    """LineDashes Menu
+
+    The values are taken from StandardDashes()
+    """
+
+    mode = CommonOptionMenu.TEMPORARY_EXTENSION
+
+    def __init__(self):
+        CommonOptionMenu.__init__(self, StandardDashes())
+
+    def build_options(self):
+        window = self.window
+        options = []
+        for dash in self.values:
+            widget = DashesWidget(dash)
+            #widget = gtk.Label(str(dash))
+            options.append(widget)
+
+        return options, 0
+
+
+
+class LineWidthMenu(CommonOptionMenu):
+
+    """Line Width Menu
+
+    Values are taken from and saved in Sketch.UI.preferences.
+    Values are stored internally in points (pts), but the unit of display
+    can be set with SetUnits().
+    New widths can be added with AddWidth(), which will remove the oldest
+    width if the menu grows too big (size set in Sketch.UI.preferences).
+    """
+
+    def __init__(self):
+        values = Sketch.UI.preferences.user_line_widths
+        limit = Sketch.UI.preferences.user_line_widths_length
+        if len(values) > limit:
+            values = values[:limit]
+        self.order = values[:]
+        values.sort()
+        self.scale = 1.0
+        self.digits = 1
+        CommonOptionMenu.__init__(self, values)
+
+    def build_options(self):
+        options = []
+        for width in self.values:
+            widget = ThicknessWidget(width)
+            options.append(widget)
+        return options, 0
+
+    def SetUnits(self, scale, digits):
+        update = self.scale != scale or self.digits != digits
+        self.scale = scale
+        self.digits = digits
+        if update:
+            self.update()
+
+    def AddWidth(self, width):
+        if self.order.count(width):
+            self.order.remove(width)
+            self.order[:0] = [width]
+        else:
+            self.order[:0] = [width]
+            limit = Sketch.UI.preferences.user_line_widths_length
+            if len(self.order) > limit:
+                self.order = self.order[:limit]
+            self.values = self.order[:]
+            self.values.sort()
+            self.base_values = self.values
+            self.update()
+        self.SetOption(width)
+        Sketch.UI.preferences.user_line_widths = self.order
+
+class LineInspector(Card):
+    """Inspector for setting line styles."""
+    
+    def __init__(self, application):
+        self.active_frame = None
+
+        # changes are collected in a buffer before they are executed.
+        self.buffer = {}
+
+        # locks fulfill two tasks here: blocking "apply" and blocking
+        # the unsetting of the "undo_last" flag.        
+        self.locked = 0
+
+        # the changes that were done last time
+        self.last_changes = None
+
+        # whether the "apply" entry should be activeated
+        self.has_changes = 1
+        
+        self.no_line = 0
+        self.unit_scale = 1.0
+        self.current_width = 1.0
+        
+        Card.__init__(self, application, _("Line"))
+
+        for signal in (CHANGED, SELECTION, EDITED, OBJECT_CHANGED):            
+            self.context.Subscribe(signal, self.context_changed)
+
+    def build_card(self):
+        vbox = self
+        application = self.context.application
+        # no line, color
+        color_hbox = gtk.HBox(homogeneous = 1)
+        self.none = none = gtk.ToggleButton(_("No Line"))
+        none.connect('clicked', self.on_none)
+        
+        self.color = color = ColorButton(application, _("Color"),
+                                         StandardColors.black)
+        color.Subscribe(CHANGED, self.on_color)
+        color_hbox.pack_start(none, 0, 1)
+        color_hbox.pack_start(color, 0, 1)
+        
+        # width, units
+        label = gtk.Label(_("Width:"))
+        width_hbox = gtk.HBox(homogeneous = 0)
+        adjust = gtk.Adjustment(1, 0, 72, 1, 0, 0)
+        self.width = width = gtk.SpinButton(adjust)
+        width.set_width_chars(4)
+        width.connect('changed', self.on_width)
+        self.unit_menu = unit_menu = UnitMenu()
+        unit_menu.Subscribe(CHANGED, self.on_units)
+        width_hbox.pack_start(label, 0, 1)
+        width_hbox.pack_start(width, 1, 1)
+        width_hbox.pack_start(unit_menu, 0, 1)
+        
+        # width option menu
+        width_menu_hbox = gtk.HBox(homogeneous = 0)
+        self.width_menu = width_menu = LineWidthMenu()
+        width_menu.Subscribe(CHANGED, self.on_width_menu)
+        self.add_button = add_button = gtk.Button(_("Add"))
+        add_button.connect('clicked', self.on_add)
+        width_menu_hbox.pack_start(width_menu, 1, 1)
+        width_menu_hbox.pack_start(add_button, 0, 1)
+        
+        # reset width adjustment to default unit
+        self.on_units(unit_menu.GetOption())
+        
+        # dash option menu
+        self.dash_menu = dash_menu = LineDashesMenu()
+        dash_menu.Subscribe(CHANGED, self.on_dashes)
+        
+        # arrows
+        self.left_arrow = left_arrow = ArrowMenu(0)
+        left_arrow.Subscribe(CHANGED, self.on_line_arrow1)
+        self.right_arrow = right_arrow = ArrowMenu(1)
+        right_arrow.Subscribe(CHANGED, self.on_line_arrow2)
+
+        # cap
+        line_cap = PixmapMenu(['CapButt', 'CapRound', 'CapProjecting'],
+                               [CapButt, CapRound, CapProjecting])
+        line_cap.Subscribe(CHANGED, self.on_line_cap)
+        self.line_cap = line_cap
+
+        # join
+        line_join = PixmapMenu(['JoinMiter', 'JoinRound', 'JoinBevel'],
+                                 [JoinMiter, JoinRound, JoinBevel])
+        
+        line_join.Subscribe(CHANGED, self.on_line_join)
+        self.line_join = line_join
+        
+        table = gtk.Table(2, 2, homogeneous = 0)
+        table.attach(left_arrow, 0, 1, 0, 1)
+        table.attach(right_arrow, 1, 2, 0, 1)
+        table.attach(line_join, 0, 1, 1, 2)
+        table.attach(line_cap, 1, 2, 1, 2)
+
+        vbox.pack_start(color_hbox, 0, 1)
+        vbox.pack_start(width_hbox, 0, 1)
+        vbox.pack_start(width_menu_hbox, 0, 1)
+        vbox.pack_start(dash_menu, 0, 1)
+        vbox.pack_start(table, 0, 1)
+        vbox.show_all()
+
+    def CanApply(self):
+        return self.has_changes
+    
+    def context_changed(self, *args):
+        if self.locked: return        
+        self.last_changes = None
+        self.has_changes = 1
+        if self.IsAutoUpdate():
+            self.update()
+        else:
+            self.changed()
+
+    ### widget callbacks
+    def on_none(self, widget, *args):
+        # none is the "no line" button
+        if self.locked: return
+        self.no_line = widget.get_active()        
+        if self.no_line:
+            pattern = EmptyPattern
+        else:
+            pattern = SolidPattern(self.color.Color())
+        self.auto_apply(line_pattern = pattern)
+                
+    def on_color(self, color):
+        if self.locked: return
+        if color == EmptyPattern:
+            pattern = EmptyPattern
+        else:
+            pattern = SolidPattern(color)
+
+        self.lock()
+        self.set_pattern(pattern)
+        self.unlock()
+        self.auto_apply(line_pattern = pattern)
+        
+    def on_width(self, widget, *args):
+        if self.locked: return
+        width = widget.get_value()
+        width = width * self.unit_scale
+        self.lock()
+        self.set_width_menu(width)
+        self.unlock()
+        self.auto_apply(line_width = width)
+
+    def on_width_menu(self, width):
+        if self.locked: return
+        self.lock()
+        self.set_width(width)
+        self.unlock()
+        self.auto_apply(line_width = width)
+        
+    def on_add(self, widget, *args):
+        if self.locked: return
+        width = self.width.get_value()
+        width = width * self.unit_scale
+        self.lock()
+        self.width_menu.AddWidth(width)
+        self.unlock()
+        
+    def on_units(self, value):
+        if self.locked: return
+        unit, scale = value
+        adj = self.width.get_adjustment()
+        width = self.width.get_value()
+        width = self.unit_scale * width / scale
+        digits = max(0, int(1.5 + log10(scale)))
+        
+        # Black-magic (tm) step size calculation: Tries to get a nice
+        # "round" number close to 1 pt.  Yields 0.01 in, 1 pt, 1 mm,
+        # 0.1 cm and should give reasonable values for arbitrary
+        # units.
+        ten_scale = 10.0**(digits - 1)
+        step = max(1, int((1.0 / scale) * ten_scale + 0.5)) / ten_scale
+        self.lock()
+        # XXX Arbitary upper limit of 12 inches.  Is this reasonable
+        # or should it be larger or smaller?  Note that 0.6 had no
+        # upper limit.
+        adj.set_all(width, 0, 12.0 * 72.0 / scale, step, 0, 0)
+        self.unit_scale = scale
+
+        self.width.set_digits(digits)
+        self.width.set_adjustment(adj)
+        self.width_menu.SetUnits(scale, digits)
+        self.set_width(width)
+        self.unlock()
+        
+    def on_dashes(self, dashes):
+        if self.locked: return
+        self.auto_apply(line_dashes = dashes)
+
+    def on_line_arrow1(self, arrow):
+        if self.locked: return
+        self.auto_apply(line_arrow1 = arrow)
+
+    def on_line_arrow2(self, arrow):
+        if self.locked: return
+        self.auto_apply(line_arrow2 = arrow)
+
+    def on_line_cap(self, line_cap):
+        if self.locked: return
+        self.auto_apply(line_cap = line_cap)
+
+    def on_line_join(self, line_join):
+        if self.locked: return
+        self.auto_apply(line_join = line_join)
+                          
+    # helpers
+    def set_pattern(self, pattern):
+        #print "set pattern:locked= ", self.locked, pattern
+        if pattern is EmptyPattern:
+            self.no_line = 1
+            self.none.set_active(1)
+        else:
+            self.no_line = 0
+            self.none.set_active(0)
+            self.color.SetColor(pattern.color)
+        
+    def set_width(self, width):
+        self.width.set_value(width / self.unit_scale)
+        self.width_menu.SetOption(width)
+
+    def set_width_menu(self, width):
+        self.width_menu.SetOption(width)
+        
+    def extract_properties(self):
+        pattern = EmptyPattern
+        if not self.no_line:
+            pattern = SolidPattern(self.color.Color())
+        width = self.width.get_value()
+        width = width / self.unit_scale
+        properties = {}
+        properties['line_width'] = width
+        properties['line_dashes'] = self.dash_menu.GetOption()
+        properties['line_arrow1'] = self.left_arrow.GetOption()
+        properties['line_arrow2'] = self.right_arrow.GetOption()
+        properties['line_pattern'] = pattern
+        properties['line_join'] = self.line_join.GetOption()
+        properties['line_cap'] = self.line_cap.GetOption()
+        for property in ('line_width', 'line_dashes', 'line_pattern',
+                         'line_cap', 'line_join'):
+            if properties[property] is None:
+                del properties[property]
+        return properties
+    
+    def lock(self):
+        self.locked = 1
+
+    def unlock(self):
+        self.locked = 0
+
+    def update(self):
+        """Update the inspector from selection"""
+        if not self.context.HasEditor() or self.locked:
+            return
+        
+        # Updating the widges may trigger their callbacks which would
+        # lead to calls to apply. Set updating to true to tell apply
+        # to ignore this.
+        self.lock()
+
+        objects = self.context.editor.SelectedObjects()
+        properties = common_object_properties(objects)
+        
+        pattern = properties.line_pattern
+        self.set_pattern(pattern)
+        
+        width = properties.line_width        
+        if width is not None:
+            self.set_width(width)
+            
+        self.dash_menu.SetOption(properties.line_dashes)
+        self.line_cap.SetOption(properties.line_cap)
+        self.line_join.SetOption(properties.line_join)
+        self.left_arrow.SetOption(properties.line_arrow1)
+        self.right_arrow.SetOption(properties.line_arrow2)
+
+        self.has_changes = 0
+        self.buffer = {}
+        self.unlock()
+
+    def auto_apply(self, **kw):
+        if self.locked or self.context is None:
+            return
+        
+        self.buffer.update(kw)
+        self.has_changes = 1
+        if self.IsAutoApply():
+            self.do_apply()
+        else:
+            self.changed()
+            
+    def do_apply(self, all=0):
+        #print "do_apply: locked=", self.locked
+        context = self.context
+        if not context.HasEditor():
+            return
+
+        # prevent the undo_last flag from being unset  
+        self.lock()
+        undo = context.document.undo
+
+        # if "all" is true add properties from all widgets
+        if all:
+            self.buffer.update(self.extract_properties())
+            
+        changes = Set(self.buffer.keys())
+
+        # if this transaction will make the last one completely
+        # obsolete, we can save one undo.
+        last_changes = self.last_changes
+        if last_changes is not None and last_changes.issubset(changes):
+            undo.Undo() 
+            
+        context.editor.SetProperties(**self.buffer)
+        self.last_changes = changes
+        self.buffer = {}
+        self.has_changes = 0
+        self.unlock()
+        self.changed()
+        
+class LinePanel(MultiPanel):
+    multiple = 1
+    def __init__(self, context):
+        MultiPanel.__init__(self, context, _("Line"))
+
+    def build_window(self):
+        MultiPanel.build_window(self)
+        card = LineInspector(self.context.application)
+        self.build_menu()
+        self.attach_card(card)
+        
+    def build_menu(self):        
+        items = (
+            #'issue_panel_changed',
+                 'close_panel',
+                 'duplicate_panel',
+                 None,
+                 'auto_update',
+                 'auto_apply',
+                 'update_panel',
+                 'do_apply')
+        #menudata = Sketch.Editor.BuildMenuTree('<linemenu>', '', items)
+        import tmpmenu
+        menudata = tmpmenu.BuildMenuTree('<fillmenu>', '', items)
+        self.set_menudata(menudata)
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/properties.py sketch1/Sketch/UI/properties.py
--- sketch.orig/Sketch/UI/properties.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/properties.py	2005-03-19 22:02:44.000000000 +0100
@@ -26,88 +26,15 @@
 import Sketch, Sketch.Graphics
 
 from gtkmisc import SketchDrawingArea
-from skpanel import SketchPanel
-from gtkdevice import PatternDevice
+from skpanel import MultiPanel, Card
+from rendermisc import PatternSample, ImageRenderer
+from command import make_command
+
 import skpixmaps
 pixmaps = skpixmaps.pixmaps
 
 
-class PatternSample(SketchDrawingArea):
 
-    def __init__(self,  **kw):
-        apply(SketchDrawingArea.__init__, (self,), kw)
-        self.pattern = EmptyPattern
-        self.properties = PropertyStack()
-        self.properties.AddStyle(EmptyLineStyle)
-        self.properties.SetProperty(fill_pattern = self.pattern)
-        self.gc.SetProperties(self.properties)
-        self.fill_rect = None
-
-    def realize_method(self, *args):
-        apply(SketchDrawingArea.realize_method, (self,) + args)
-        self.fill_rect = Rect(0, 0, self.window.width, self.window.height)
-        self.compute_trafo()
-
-    def compute_trafo(self):
-        if not hasattr(self, 'window'):
-            return
-        height = self.window.height
-        doc_to_win = Trafo(1, 0, 0, -1, 0, height)
-        win_to_doc = doc_to_win.inverse()
-        self.gc.SetViewportTransform(1.0, doc_to_win, win_to_doc)
-        self.fill_rect = Rect(0, 0, self.window.width, self.window.height)
-        self.gc.SetProperties(self.properties, self.fill_rect)
-
-    def SetPattern(self, pattern):
-        if pattern != self.pattern:
-            self.pattern = pattern
-            self.UpdateWhenIdle()
-            self.properties.SetProperty(fill_pattern = pattern)
-            self.gc.SetProperties(self.properties, self.fill_rect)
-
-    def RedrawMethod(self, region = None):
-        win = self.window
-        #self.gc.StartDblBuffer()
-        self.gc.SetFillColor(StandardColors.white)
-        self.gc.FillRectangle(0, 0, win.width, win.height)
-        if self.properties.HasFill():
-            self.gc.Rectangle(Trafo(win.width, 0, 0, win.height, 0, 0))
-        else:
-            self.gc.SetLineColor(StandardColors.black)
-            self.gc.DrawLineXY(0, win.height, win.width, 0)
-        #self.gc.EndDblBuffer()
-
-    def ResizedMethod(self, width, height):
-        self.gc.WindowResized(width, height)
-        self.UpdateWhenIdle()
-        self.compute_trafo()
-
-
-class PreviewFactory(PatternDevice):
-
-    def __init__(self):
-        PatternDevice.__init__(self, gradient_steps =
-                               Sketch.Base.preferences.gradient_steps_editor)
-
-    def CreatePreview(self, pattern, width = 16, height = 16):
-        if pattern.preview is not None:
-            return pattern.preview
-        pixmap = gtk.create_pixmap(self.window, width, height)
-        self.drawable = pixmap
-        doc_to_win = Trafo(1, 0, 0, -1, 0, height)
-        win_to_doc = doc_to_win.inverse()
-        self.SetViewportTransform(1.0, doc_to_win, win_to_doc)
-        self.ximage = None
-        if pattern.is_procedural:
-            self.fill_rect = Rect(0, 0, width, height)
-            pattern.Execute(self, self.fill_rect)
-        else:
-            pattern.Execute(self, None)
-            self.FillRectangle(0, 0, width, height)
-        self.drawable = self.window
-        pattern.preview = pixmap
-        return pixmap
-        
 
 
 property_defs = [
@@ -124,7 +51,10 @@
     ('font_size', 'MiniFontSize', "convert_length"),
 ]
 
-maskbitmap = None
+
+
+class PreviewFactory(PatternSample, ImageRenderer):
+    pass
 
 class StyleList(gtk.CList):
 
@@ -189,7 +119,10 @@
 
     def convert_pattern(self, value):
         if value is not EmptyPattern:
-            return self.preview_factory.CreatePreview(value), maskbitmap
+            factory = self.preview_factory
+            factory.SetData(value)
+            return factory.create_pixmap(), factory.create_bitmap()
+        
         else:
             return '-'
 
@@ -205,27 +138,16 @@
         return getattr(pixmaps,
                        ('', 'CapButt', 'CapRound', 'CapProjecting')[value])
 
-class PropertyPanel(SketchPanel):
 
+class Properties(Card):
+    was_realized = 0
     def __init__(self, context):
-        SketchPanel.__init__(self, context, _("Properties"))
-        self.context.Subscribe(Sketch.Base.const.SELECTION,
-                               self.context_changed)
-        self.context.Subscribe(Sketch.Base.const.TRANSACTION_END,
-                               self.context_changed)
-        self.context.Subscribe(Sketch.Base.const.STYLE, self.style_changed)
-        self.style_changed()
-        self.context_changed()
+        Card.__init__(self, context, _("Properties"))
 
-    def build_window(self):
-        vbox = self.vbox
+    def build_card(self):
+        vbox = self
         self.preview_factory = PreviewFactory()
 
-        #self.fillsample = PatternSample()
-        #self.fillsample.size(100, 100)
-        #self.fillsample.show()
-        #vbox.pack_start(self.fillsample)
-
         notebook = gtk.Notebook()
         vbox.pack_start(notebook)
 
@@ -239,23 +161,29 @@
         swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)        
         self.dynamic_styles = StyleList(self.preview_factory)
         swin.add(self.dynamic_styles)
-        notebook.append_page(swin, gtk.Label(_("Styles")))
-        
+        notebook.append_page(swin, gtk.Label(_("Styles")))        
         vbox.show_all()
 
-        vbox.realize()
-        self.preview_factory.init_gc(vbox.window)
-        global maskbitmap
-        maskbitmap = gtk.gdk.bitmap_create_from_data(vbox.window, '\377'*32,
-                                                     16, 16)
+
+    def realized(self, *rest):
+        self.was_realized = 1
+        self.preview_factory.init_gc(self.window)
+        self.context.Subscribe(Sketch.Base.const.SELECTION,
+                               self.context_changed)
+        self.context.Subscribe(Sketch.Base.const.TRANSACTION_END,
+                               self.context_changed)
+        self.context.Subscribe(Sketch.Base.const.STYLE, self.style_changed)
+        self.context_changed()
+
 
     def close(self, *args):
-        self.context.Unsubscribe(Sketch.Base.const.SELECTION,
-                                 self.context_changed)
-        self.context.Unsubscribe(Sketch.Base.const.STYLE, self.style_changed)
-        self.context.Unsubscribe(Sketch.const.TRANSACTION_END,
-                                 self.context_changed)
-        SketchPanel.close(self)
+        if self.was_realized:
+            self.context.Unsubscribe(Sketch.Base.const.SELECTION,
+                                     self.context_changed)
+            self.context.Unsubscribe(Sketch.Base.const.STYLE, self.style_changed)
+            self.context.Unsubscribe(Sketch.const.TRANSACTION_END,
+                                     self.context_changed)
+        Card.close(self)
 
     def context_changed(self, *args):
         #print 'context_changed'
@@ -280,3 +208,118 @@
             self.dynamic_styles.SetStyleList(self.context.document.Styles())
         else:
             self.dynamic_styles.SetStyleList([])
+
+        
+class PropertyInspector(Card):
+
+    was_realized = 0
+    def __init__(self, application):
+        Card.__init__(self, application, _("Properties"))    
+
+    def build_card(self):
+        swin = gtk.ScrolledWindow()
+        swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self.add(swin)
+        self.preview_factory = PreviewFactory()
+        self.current_styles = StyleList(self.preview_factory)
+        swin.add(self.current_styles)
+     
+
+        def _stock_button(descr):            
+            button = gtk.Button()
+            image = gtk.Image()
+            image.set_from_stock(descr, gtk.ICON_SIZE_BUTTON)            
+            button.add(image)
+            return button
+
+        hbox = gtk.HBox()
+        
+        button = _stock_button(gtk.STOCK_NEW)
+        hbox.pack_start(button )
+
+        button = _stock_button(gtk.STOCK_GO_UP)
+        hbox.pack_start(button )
+        
+        button = _stock_button(gtk.STOCK_GO_DOWN)
+        hbox.pack_start(button )
+
+        button = _stock_button(gtk.STOCK_DELETE)
+        hbox.pack_start(button )
+        
+        self.pack_start(hbox, expand=0 )
+        self.show_all()
+
+    def realized(self, *args):
+        self.preview_factory.init_gc(self.window)
+        context = self.context
+        context.Subscribe(Sketch.Base.const.SELECTION,
+                          self.context_changed)
+        context.Subscribe(Sketch.Base.const.TRANSACTION_END,
+                          self.context_changed)
+        self.was_realized = 1
+
+    def destroyed(self, *args):
+        if self.was_realized:
+            self.context.Unsubscribe(Sketch.Base.const.SELECTION,
+                                     self.context_changed)
+            self.context.Unsubscribe(Sketch.const.TRANSACTION_END,
+                                     self.context_changed)
+        Card.destroyed(self)
+
+    def context_changed(self, *args):
+        pattern = EmptyPattern
+        properties = None
+        if self.context.HasEditor():
+            obj = self.context.editor.CurrentObject()
+            if obj is not None and obj.has_properties:
+                properties = obj.Properties()
+                if obj.has_fill:
+                    pattern = properties.fill_pattern.Copy()
+
+        self.properties = properties
+        if properties is not None:
+            self.current_styles.SetStyleList(properties.Styles())
+        else:
+            self.current_styles.SetStyleList([])
+
+    def create_memo(self, *args):
+        memo = PropertyStackMemo(self, self.context, self.properties)
+        memo.show()
+
+    def get(self):
+        return self.properties.Duplicate()
+
+    def set(self, data):
+        pass
+
+class PropertyPanel(MultiPanel):
+    multiple = 1
+    def __init__(self, context):
+        MultiPanel.__init__(self, context, _("Propety Inspector"))
+        self.set_resizable(1)
+
+    def build_window(self):
+        MultiPanel.build_window(self)
+        self.build_menu()
+
+        application = self.context.application
+        #card = PropertyInspector(application)
+        #self.attach_card(card)        
+        card = Properties(application)
+        self.attach_card(card)        
+
+    def build_menu(self):        
+        items = (
+            #'issue_panel_changed',
+                 'close_panel',
+                 'duplicate_panel',
+                 None,
+                 'auto_update',
+                 'auto_apply',
+                 'update_panel',
+                 'do_apply')
+            
+        #menudata = Sketch.Editor.BuildMenuTree('<stackinspectormenu>', '', items)
+        import tmpmenu
+        menudata = tmpmenu.BuildMenuTree('<stackinspectormenu>', '', items)
+        self.set_menudata(menudata)
